#!/usr/bin/env node
"use strict";
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var program = require("commander");
var restApi_1 = require("./restApi");
var updateNotifier = require("update-notifier");
var pkg = require('../package.json');
var tasks = {
    generateApi: function (projectName, chaincode) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log("in generateApi in command.ts chaincode=" + chaincode);
                        return [4, restApi_1.RestApi.generateApi(projectName, chaincode)];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    },
    compileApiApplication: function (chaincode) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log("in compileApiApplication in command.ts chaincode=" + chaincode);
                        return [4, restApi_1.RestApi.compileApiApplication(chaincode)];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    },
    startApiApplication: function (chaincode) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log("in startApiApplication in command.ts chaincode=" + chaincode);
                        return [4, restApi_1.RestApi.startApiApplication(chaincode)];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    }
};
program
    .command('generate <object>')
    .option('-c, --chaincode <chaincode>', 'Chaincode project')
    .option('-p, --projectname <projectname>', 'name of the API project')
    .action(function (object, cmd) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    var _a;
    return tslib_1.__generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                console.log("cmd.chaincode=" + cmd.chaincode);
                console.log("cmd.projectname=" + cmd.projectname);
                if ((!cmd || !cmd.chaincode) && object == 'api') {
                    throw new Error('Please specify the chaincode project with the parameter -c');
                }
                if ((!cmd || !cmd.projectname) && object == 'api') {
                    throw new Error('Please specify the project name with the parameter -p');
                }
                _a = object;
                switch (_a) {
                    case 'api': return [3, 1];
                }
                return [3, 3];
            case 1: return [4, tasks.generateApi(cmd.projectname, cmd.chaincode)];
            case 2: return [2, _b.sent()];
            case 3: throw new Error("Option " + object + " is not a valid generator. Try with 'api'.");
        }
    });
}); });
program
    .command('compile <chaincode>')
    .action(function (chaincode) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, tasks.compileApiApplication(chaincode)];
            case 1:
                _a.sent();
                return [2];
        }
    });
}); });
program
    .command('start <chaincode>')
    .action(function (chaincode) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, tasks.startApiApplication(chaincode)];
            case 1:
                _a.sent();
                return [2];
        }
    });
}); });
updateNotifier({
    pkg: pkg,
    updateCheckInterval: 1000 * 60
}).notify();
program.parse(process.argv);
//# sourceMappingURL=command.js.map