"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var sysWrapper_1 = require("../utils/sysWrapper");
var smartModel_1 = require("../models/smartModel");
var EnvModel = (function (_super) {
    tslib_1.__extends(EnvModel, _super);
    function EnvModel(name, chaincodeName, projectName, ignoreConvention) {
        var _this = _super.call(this, name, projectName) || this;
        _this.name = name;
        _this.chaincodeName = chaincodeName;
        _this.projectName = projectName;
        _this.ignoreConvention = ignoreConvention;
        return _this;
    }
    EnvModel.prototype.recompile = function () {
        throw new Error('Method not implemented.');
    };
    EnvModel.prototype.save = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, sysWrapper_1.SysWrapper.createFileFromTemplate(this.filePath, {
                            apiEnvironment: this.selectedApiConfig
                        }, this.templateFile)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Object.defineProperty(EnvModel.prototype, "applicationName", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-app';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EnvModel.prototype, "selectedApiConfig", {
        get: function () {
            var apiConfig = require(this.projectRoot + "/" + 'api.json');
            var selectedEnv = apiConfig.selected;
            var currentEnvObject;
            for (var _i = 0, _a = apiConfig.environments; _i < _a.length; _i++) {
                var environment = _a[_i];
                if (environment.name == selectedEnv) {
                    currentEnvObject = environment;
                    break;
                }
            }
            return currentEnvObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EnvModel.prototype, "templateFile", {
        get: function () {
            return path_1.join(__dirname, '../../templates/_.env.ts.ejs');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EnvModel.prototype, "filePath", {
        get: function () {
            return this.projectRoot + "/packages/" + this.applicationName + "/.env";
        },
        enumerable: true,
        configurable: true
    });
    return EnvModel;
}(smartModel_1.SmartModel));
exports.EnvModel = EnvModel;
//# sourceMappingURL=env.smart-model.js.map