"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var sysWrapper_1 = require("../utils/sysWrapper");
var smartModel_1 = require("./smartModel");
var ReadmeModel = (function (_super) {
    tslib_1.__extends(ReadmeModel, _super);
    function ReadmeModel(name, projectName, ignoreConvention) {
        var _this = _super.call(this, name, projectName) || this;
        _this.name = name;
        _this.projectName = projectName;
        _this.ignoreConvention = ignoreConvention;
        return _this;
    }
    ReadmeModel.prototype.save = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, sysWrapper_1.SysWrapper.createFile(this.filePath, "# " + this.projectName + " - " + this.name + "\n\nThis awesome project was created automatically with <a href=\"https://github.com/xcottos/convector-rest-api\" target=\"_blank\">Convector Rest API</a>.\n\n")];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Object.defineProperty(ReadmeModel.prototype, "templateFile", {
        get: function () {
            return path_1.join(__dirname, '../../templates/_controller.ts.ejs');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReadmeModel.prototype, "filePath", {
        get: function () {
            if (!this.ignoreConvention) {
                return this.projectRoot + "/README.md";
            }
            else {
                return path_1.join(process.cwd(), "README.md");
            }
        },
        enumerable: true,
        configurable: true
    });
    return ReadmeModel;
}(smartModel_1.SmartModel));
exports.ReadmeModel = ReadmeModel;
//# sourceMappingURL=readme.model.js.map