"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var sysWrapper_1 = require("../utils/sysWrapper");
var smartModel_1 = require("../models/smartModel");
var SmartApiController = (function (_super) {
    tslib_1.__extends(SmartApiController, _super);
    function SmartApiController(name, chaincodeName, projectName, methods, controllerClassName, ignoreConvention) {
        var _this = _super.call(this, name, projectName) || this;
        _this.name = name;
        _this.chaincodeName = chaincodeName;
        _this.projectName = projectName;
        _this.methods = methods;
        _this.controllerClassName = controllerClassName;
        _this.ignoreConvention = ignoreConvention;
        return _this;
    }
    SmartApiController.prototype.recompile = function () {
        throw new Error('Method not implemented.');
    };
    SmartApiController.prototype.save = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, sysWrapper_1.SysWrapper.createFileFromTemplate(this.filePath, {
                            dto: this.getDTO()
                        }, this.templateFile)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Object.defineProperty(SmartApiController.prototype, "chaincodeClientFolder", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-cc/client';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartApiController.prototype, "applicationName", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-app';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartApiController.prototype, "templateFile", {
        get: function () {
            return path_1.join(__dirname, '../../templates/_smartApiController.ts.ejs');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartApiController.prototype, "filePath", {
        get: function () {
            return this.projectRoot + "/packages/" + this.applicationName + "/server/api/controllers/examples/controller.ts";
        },
        enumerable: true,
        configurable: true
    });
    SmartApiController.prototype.getDTO = function () {
        var dto = {};
        var getAllMethods = [];
        var getByIdMethods = [];
        var createMethods = [];
        var serviceMethods = [];
        for (var _i = 0, _a = this.methods; _i < _a.length; _i++) {
            var method = _a[_i];
            if (method.getDecorator("GetAll")) {
                getAllMethods.push(method.getName());
            }
            else if (method.getDecorator("GetById")) {
                getByIdMethods.push(method.getName());
            }
            else if (method.getDecorator("Create")) {
                var createObj = {};
                createObj.methodName = method.getName();
                createObj.methodParameterType = method.getDecorator("Create").getArguments()[0].getText().replace(/[ '|\" ]/g, '');
                console.log(JSON.stringify(createObj));
                createMethods.push(createObj);
            }
            else if (method.getDecorator("Service")) {
                console.log(method.getName() + " è un service");
                var serviceObj = {};
                serviceObj.methodName = method.getName();
                serviceObj.parameters = method.getParameters();
                serviceMethods.push(serviceObj);
            }
            var methodParameters = method.getParameters();
            if (methodParameters.length == 0) {
            }
            for (var _b = 0, methodParameters_1 = methodParameters; _b < methodParameters_1.length; _b++) {
                var j = methodParameters_1[_b];
                var paramTypeSymbol = j.getType().getSymbol();
                if (paramTypeSymbol == undefined) {
                }
                else {
                }
            }
        }
        dto.controllerClassName = this.controllerClassName;
        dto.getAllMethods = getAllMethods;
        dto.getByIdMethods = getByIdMethods;
        dto.createMethods = createMethods;
        dto.serviceMethods = serviceMethods;
        return dto;
    };
    return SmartApiController;
}(smartModel_1.SmartModel));
exports.SmartApiController = SmartApiController;
//# sourceMappingURL=smartApiController.smart-model.js.map