"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var sysWrapper_1 = require("../utils/sysWrapper");
var smartModel_1 = require("../models/smartModel");
var SmartContractControllers = (function (_super) {
    tslib_1.__extends(SmartContractControllers, _super);
    function SmartContractControllers(name, chaincodeName, projectName, ignoreConvention) {
        var _this = _super.call(this, name, projectName) || this;
        _this.name = name;
        _this.chaincodeName = chaincodeName;
        _this.projectName = projectName;
        _this.ignoreConvention = ignoreConvention;
        return _this;
    }
    SmartContractControllers.prototype.recompile = function () {
        throw new Error('Method not implemented.');
    };
    SmartContractControllers.prototype.save = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, sysWrapper_1.SysWrapper.createFileFromTemplate(this.filePath, {
                            dto: this.getDTO()
                        }, this.templateFile)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Object.defineProperty(SmartContractControllers.prototype, "controllerClient", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word.charAt(0).toUpperCase() + word.substr(1).toLowerCase() + 'ControllerClient';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractControllers.prototype, "chaincodeClientFolder", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-cc/client';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractControllers.prototype, "controllerName", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word.charAt(0).toUpperCase() + word.substr(1).toLowerCase() + 'Controller';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractControllers.prototype, "applicationName", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-app';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractControllers.prototype, "templateFile", {
        get: function () {
            return path_1.join(__dirname, '../../templates/_smartContractControllers.ts.ejs');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractControllers.prototype, "filePath", {
        get: function () {
            return this.projectRoot + "/packages/" + this.applicationName + "/server/smartContractControllers.ts";
        },
        enumerable: true,
        configurable: true
    });
    SmartContractControllers.prototype.getDTO = function () {
        var dto = {};
        dto.controllerClient = this.controllerClient;
        dto.chaincodeClientFolder = this.chaincodeClientFolder;
        dto.controllerName = this.controllerName;
        return dto;
    };
    return SmartContractControllers;
}(smartModel_1.SmartModel));
exports.SmartContractControllers = SmartContractControllers;
//# sourceMappingURL=smartContractControllers.smart-model.js.map