"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var sysWrapper_1 = require("../utils/sysWrapper");
var smartModel_1 = require("../models/smartModel");
var SmartContractModels = (function (_super) {
    tslib_1.__extends(SmartContractModels, _super);
    function SmartContractModels(name, chaincodeName, projectName, models, ignoreConvention) {
        var _this = _super.call(this, name, projectName) || this;
        _this.name = name;
        _this.chaincodeName = chaincodeName;
        _this.projectName = projectName;
        _this.models = models;
        _this.ignoreConvention = ignoreConvention;
        return _this;
    }
    SmartContractModels.prototype.recompile = function () {
        throw new Error('Method not implemented.');
    };
    SmartContractModels.prototype.save = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, sysWrapper_1.SysWrapper.createFileFromTemplate(this.filePath, {
                            dto: this.getDTO()
                        }, this.templateFile)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Object.defineProperty(SmartContractModels.prototype, "chaincodeClientFolder", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-cc/client';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractModels.prototype, "applicationName", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-app';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractModels.prototype, "templateFile", {
        get: function () {
            return path_1.join(__dirname, '../../templates/_smartContractModels.ts.ejs');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartContractModels.prototype, "filePath", {
        get: function () {
            return this.projectRoot + "/packages/" + this.applicationName + "/server/smartContractModels.ts";
        },
        enumerable: true,
        configurable: true
    });
    SmartContractModels.prototype.getDTO = function () {
        var dto = {};
        dto.models = this.models;
        dto.chaincodeClientFolder = this.chaincodeClientFolder;
        return dto;
    };
    return SmartContractModels;
}(smartModel_1.SmartModel));
exports.SmartContractModels = SmartContractModels;
//# sourceMappingURL=smartContractModels.smart-model.js.map