"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var sysWrapper_1 = require("../utils/sysWrapper");
var smartModel_1 = require("../models/smartModel");
var SmartRoutesModels = (function (_super) {
    tslib_1.__extends(SmartRoutesModels, _super);
    function SmartRoutesModels(name, chaincodeName, projectName, ignoreConvention) {
        var _this = _super.call(this, name, projectName) || this;
        _this.name = name;
        _this.chaincodeName = chaincodeName;
        _this.projectName = projectName;
        _this.ignoreConvention = ignoreConvention;
        return _this;
    }
    SmartRoutesModels.prototype.recompile = function () {
        throw new Error('Method not implemented.');
    };
    SmartRoutesModels.prototype.save = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, sysWrapper_1.SysWrapper.createFileFromTemplate(this.filePath, {
                            projectName: this.projectName
                        }, this.templateFile)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Object.defineProperty(SmartRoutesModels.prototype, "chaincodeClientFolder", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-cc/client';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartRoutesModels.prototype, "applicationName", {
        get: function () {
            return this.chaincodeName.match(/[a-z]+/gi)
                .map(function (word) {
                return word + '-app';
            })
                .join('');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartRoutesModels.prototype, "templateFile", {
        get: function () {
            return path_1.join(__dirname, '../../templates/_smartRoutes.ts.ejs');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmartRoutesModels.prototype, "filePath", {
        get: function () {
            return "packages/" + this.applicationName + "/server/routes.ts";
        },
        enumerable: true,
        configurable: true
    });
    return SmartRoutesModels;
}(smartModel_1.SmartModel));
exports.SmartRoutesModels = SmartRoutesModels;
//# sourceMappingURL=smartRoutes.smart-model.js.map