"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var apiGenerator_1 = require("./apiGenerator");
var analytics_1 = require("./utils/analytics");
var sysWrapper_1 = require("./utils/sysWrapper");
var RestApi = (function () {
    function RestApi(name, chaincode) {
        this.name = name;
        this.chaincode = chaincode;
        this.analytics = new analytics_1.Analytics();
        this.chaincode = this.chaincode || this.name;
    }
    RestApi.generateApi = function (projectName, chaincode) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var restApi;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        restApi = new RestApi(projectName, chaincode);
                        return [4, restApi.generateApi(projectName, chaincode)];
                    case 1:
                        _a.sent();
                        return [2, restApi];
                }
            });
        });
    };
    RestApi.prototype.generateApi = function (projectName, chaincode) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var apiGenerator;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        apiGenerator = new apiGenerator_1.ApiGenerator(this.name, projectName, chaincode);
                        return [4, apiGenerator.generate()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    RestApi.compileApiApplication = function (chaincode) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var command, tags;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        command = 'npx';
                        tags = ['lerna', 'run', 'compile', '--scope', chaincode + '-app'];
                        return [4, sysWrapper_1.SysWrapper.executeCommand(command, tags)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    RestApi.startApiApplication = function (chaincode) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var command, tags;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        command = 'npx';
                        tags = ['lerna', 'run', 'dev', '--scope', chaincode + '-app', '--stream'];
                        return [4, sysWrapper_1.SysWrapper.executeCommand(command, tags)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    return RestApi;
}());
exports.RestApi = RestApi;
//# sourceMappingURL=restApi.js.map