import { ImportDeclaration, ClassDeclaration, MethodDeclaration, PropertyDeclarationStructure, SourceFile } from "ts-simple-ast";
export declare module ReflectionUtils {
    function getClassNames(pathPattern: string): Promise<string[]>;
    function getFirstClass(pathPattern: string): Promise<ClassDeclaration>;
    function getImportDeclarations(pathPattern: string): Promise<ImportDeclaration[]>;
    function getClassImportDeclarations(pathPattern: string, className: string): Promise<ImportDeclaration[]>;
    function getClass(pathPattern: string, className: string): Promise<ClassDeclaration>;
    function getClassFromSource(sourceFile: SourceFile, className: string): Promise<ClassDeclaration>;
    function getClasses(pathPattern: string): Promise<ClassDeclaration[]>;
    function getClassMethods(pathPattern: string, className: string): Promise<MethodDeclaration[]>;
    function getClassParameters(pathPattern: string, className: string): Promise<PropertyDeclarationStructure[]>;
    function getClassParametersFull(pathPattern: string, className: string, fullClassProperties: PropertyDeclarationStructure[]): Promise<PropertyDeclarationStructure[]>;
}
