export declare module SysWrapper {
    function createFile(filePath: string, contents: string): Promise<void>;
    function createFileFromTemplate(filePath: string, contents: any, templatePath: string): Promise<void | {}>;
    function createFileRaw(filePath: string, contents: Buffer): Promise<void>;
    function removePath(filePath: string): Promise<void>;
    function getFile(filePath: string, content?: any): Promise<string>;
    function execFile(filePath: string, content?: any): Promise<void>;
    function getFileRaw(filePath: string): Promise<Buffer>;
    function copyFile(from: string, to: string): Promise<void>;
    function existsPath(filePath: string): Promise<boolean>;
    function createJSON(filePath: string, contents: any): Promise<void>;
    function getJSON(filePath: string): Promise<any>;
    function createFolder(folder: string): Promise<void>;
    function renderTemplateFromFile(filePath: string, content: any): Promise<string>;
    function renderTemplateFromContent(templateContent: string, content: any): Promise<string>;
    function enumFilesInFolder(folder: string): Promise<string[]>;
    function enumFilesInFolderFiltered(folder: string, pattern: string): Promise<string[]>;
    function executeCommand(command: string, tags: string[]): Promise<string>;
}
